package application;

import java.util.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;

import language.*;

import static logging.Logging.logger;

public class Editor extends JTabbedPane {

    public Editor() {
        addChangeListener(new TabChangeListener());
    }

    public Observer addTab(String tabName) {
        EditorContent content = new EditorContent();
        add(content);
        setTabComponentAt(indexOfComponent(content), new EditorTab(tabName));
        setSelectedComponent(content);
        return content.getEditorPane();
    }

    public void killParseThreads() {
        try {
            int cnt = getTabCount();
            for (int i = 0; i < cnt; ++i) {
                Document doc = ((EditorContent) getComponentAt(i)).
                getEditorPane().getDocument();
                if (doc instanceof XDocument) {
                    Thread parser = ((XDocument) doc).getParser();
                    if (parser != null && parser.isAlive()) {
                        parser.interrupt();
                        parser = null;
                    }
                }
            }
        } catch (Throwable t) {
            logger.throwing("application.Editor", "killParseThreads", t);
            return;
        }
        CCPopup.hide();
    }

    public class TabChangeListener implements ChangeListener {

        public void stateChanged(ChangeEvent event) {
            ((Editor) event.getSource()).killParseThreads();
            Application.getFunctionTree().update();
            repaint();
        }

    }

}
