package application;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.plaf.metal.MetalIconFactory;

public class EditorTab extends JPanel implements ActionListener{

    private JLabel nameLabel;
    private String name;

    public EditorTab(String name) {
        super(new FlowLayout(FlowLayout.LEFT, 0, 0));

        setOpaque(false);

        this.name = name;
        nameLabel = new JLabel(name);
        nameLabel.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 5));

        JButton closeButton = new JButton(new MetalIconFactory.PaletteCloseIcon());
        closeButton.setBorder(BorderFactory.createEmptyBorder());
        closeButton.setContentAreaFilled(false);
        closeButton.addActionListener(this);

        add(nameLabel);
        add(closeButton);
    }

    public void setSaved() {
        nameLabel.setText(name);
    }

    public void setUnsaved() {
        nameLabel.setText('*' + name);
    }

    public void actionPerformed(ActionEvent e) {
        Editor editor = (Editor) getParent().getParent();
        int index = editor.indexOfTabComponent(this);
        if (((EditorContent) editor.getComponentAt(index)).getEditorPane().close())
            editor.remove(index);
    }

}
