package application;

import javax.swing.*;
import static application.Actions.*;

public class ToolBar extends JToolBar {

    JButton open, save, saveAll;
    JButton undo, redo, cut, copy, paste;
    JButton compile, run, runArg, stop;

    public ToolBar() {

        open = new JButton(new ImageIcon("images/open.png"));
        open.setToolTipText("Open");
        open.addActionListener(new OpenProjectAction());
        add(open);

        save = new JButton(new ImageIcon("images/save.png"));
        save.setToolTipText("Save");
        save.addActionListener(new SaveAction());
        add(save);

        saveAll = new JButton(new ImageIcon("images/saveall.png"));
        saveAll.setToolTipText("Save all");
        saveAll.addActionListener(new SaveAllAction());
        add(saveAll);

        addSeparator();

        undo = new JButton(new ImageIcon("images/undo.png"));
        undo.setToolTipText("Undo");
        undo.addActionListener(new UndoAction());
        add(undo);

        redo = new JButton(new ImageIcon("images/redo.png"));
        redo.setToolTipText("Redo");
        redo.addActionListener(new RedoAction());
        add(redo);

        cut = new JButton(new ImageIcon("images/cut.png"));
        cut.setToolTipText("Cut");
        cut.addActionListener(new CutAction());
        add(cut);

        copy = new JButton(new ImageIcon("images/copy.png"));
        copy.setToolTipText("Copy");
        copy.addActionListener(new CopyAction());
        add(copy);

        paste = new JButton(new ImageIcon("images/paste.png"));
        paste.setToolTipText("Paste");
        paste.addActionListener(new PasteAction());
        add(paste);

        addSeparator();

        compile = new JButton(new ImageIcon("images/compile.png"));
        compile.setToolTipText("Compile");
        compile.addActionListener(new CompileAction());
        add(compile);

        run = new JButton(new ImageIcon("images/run.png"));
        run.setToolTipText("Run");
        run.addActionListener(new RunAction());
        add(run);

        runArg = new JButton(new ImageIcon("images/runarg.png"));
        runArg.setToolTipText("Run with arguments");
        runArg.addActionListener(new RunArgAction());
        add(runArg);

        stop = new JButton(new ImageIcon("images/stop.png"));
        stop.setToolTipText("Stop");
        stop.addActionListener(new StopAction());
        add(stop);

        activateRun();

    }

    public void activateRun() {
        run.setEnabled(true);
        runArg.setEnabled(true);
        stop.setEnabled(false);
    }

    public void deactivateRun() {
        run.setEnabled(false);
        runArg.setEnabled(false);
        stop.setEnabled(true);
    }

}
