package language;

import java.util.*;
import javax.swing.text.*;
import plugins.*;

public class XDocument extends PlainDocument {

    protected Thread parser = null;

    public XDocument(AbstractDocument.Content c) {
        super(c);
    }

    protected void insertUpdate(DefaultDocumentEvent chng, AttributeSet attr) {
        super.insertUpdate(chng, attr);
        PluginManager.insertUpdate(this, chng, attr);
    }

    protected void removeUpdate(DefaultDocumentEvent chng) {
        super.removeUpdate(chng);
        PluginManager.removeUpdate(this, chng);
    }

    public Thread getParser() {
        return parser;
    }

    public int startParserCurrentScope(int pos) {
        return 0;
    }

    public FunctionsTree getFunctionsTree() {
        return null;
    }

    public class FunctionsTree {

        public int pos;
        public String name;
        public List <FunctionsTree> list = new LinkedList <FunctionsTree> ();

        public FunctionsTree(int pos, String name) {
            this.pos = pos;
            this.name = name;
        }

        public String toString() {
            return name;
        }

    }

}
