package language.html;

import java.awt.Color;
import java.awt.Font;

public class HTMLToken {
    public static final int TAG_CDATA_START = 0;
    public static final int TAG_CDATA_END = 1;
    public static final int TAG_PATTERN = 2;
    public static final int TAG_ATTRIBUTE_PATTERN = 3;
    public static final int TAG_END_PATTERN = 4;
    public static final int TAG_ATTRIBUTE_VALUE = 5;
    public static final int TAG_COMMENT = 6;
    public static final int TAG_DOCTYPE = 7;

    private static final Color[] colors = { new Color(0, 160, 50), new Color(0, 160, 50),
                                            new Color(0, 160, 50), new Color(140, 0, 60),
                                            new Color(0, 160, 50), Color.MAGENTA, 
                                            Color.BLUE,			   Color.decode("#707070") };
    private static final int[] fontStyles = { Font.BOLD, Font.BOLD, Font.BOLD, Font.BOLD,
                                              Font.BOLD, Font.PLAIN, Font.PLAIN, Font.ITALIC };

    private int endPos;
    private int kind;

    public HTMLToken(int endPos, int kind) {
        this.endPos = endPos;
        this.kind = kind;
    }

    public int getKind() {
        return kind;
    }

    public int getEndPos() {
        return endPos;
    }

    public Color getColor() {
        if (kind >= 0 && kind <= 7) return colors[kind];
        return Color.BLACK;
    }

    public int getFontStyle() {
        if (kind >= 0 && kind <= 7) return fontStyles[kind];
        return Font.PLAIN;
    }
}