package language.java;

import java.awt.Color;
import java.awt.Font;

public class JavaShineColorScheme implements JavaColorScheme {

    private static final Color colors[] = new Color[151];
    private static final int styles[] = new int[151];

    public Color getColor(int token) {
        if (token > colors.length || token < 0) return Color.black;
        if (colors[token] == null) return Color.black;
        return colors[token];
    }

    public int getStyle(int token) {
        if (token > styles.length || token < 0) return 0;
        return styles[token];
    }

    {
        colors[COMMENT] = Color.blue;

        colors[TRUE] = colors[FALSE] = colors[THIS] = colors[SUPER] = colors[NULL] = new Color(60, 200, 60);
        styles[TRUE] = styles[FALSE] = styles[THIS] = styles[SUPER] = styles[NULL] = Font.BOLD;

        for (int operator = COMMA; operator <= ARRAY; operator++)
            colors[operator] = new Color(60, 200, 60);

        int[] specialOperators = {INSTANCEOF, NEWARRAY, NEWINSTANCE, NEWFROMNAME, FIELD, NEW, INC, DEC, GOTO};
        for (int op : specialOperators) {
            colors[op] = new Color(150, 0, 0);
            styles[op] = Font.BOLD;
        }

        for (int type = BYTE; type <= BOOLEAN; type++) {
            colors[type] = new Color(60, 200, 60);
            styles[type] = Font.BOLD;
        }

        for (int statement = IF; statement <= VARDECLARATION; statement++) {
            colors[statement] = new Color(60, 200, 60);
            styles[statement] = Font.BOLD;
        }

        for (int value = BOOLEANVAL; value <= STRINGVAL; value++)
            colors[value] = Color.magenta;

        for (int declaration = CLASS; declaration <= INTERFACE; declaration++) {
            colors[declaration] = Color.red;
            styles[declaration] = Font.BOLD;
        }
        colors[IMPORT] = colors[PACKAGE] = new Color(130, 0, 150);
        styles[IMPORT] = styles[PACKAGE] = Font.BOLD;
        colors[THROWS] = Color.red;
        styles[THROWS] = Font.BOLD;

        for (int modifier = PRIVATE; modifier <= STRICTFP; modifier++) {
            colors[modifier] = Color.red;
            styles[modifier] = Font.BOLD;
        }

    }

}
