package language.java.ccinfo;

import java.lang.reflect.*;
import static com.sun.tools.javac.tree.JCTree.*;

public class MethodInfo extends language.CCInfo {

    String returnType;
    String parameters;
    String declaringClass;

    public MethodInfo(Method m) {
        info = m.getName() + "(";
        for (int i = 0; i < m.getParameterTypes().length - 1; ++i)
            info += ",";
        info += ")";
        returnType = m.getReturnType().getSimpleName();
        parameters = "";
        for (Class <?> c : m.getParameterTypes()) {
            if (!parameters.equals(""))
                parameters += ", ";
            parameters += c.getSimpleName();
        }
        declaringClass = m.getDeclaringClass().getName();
    }

    public MethodInfo(JCMethodDecl m, String cls) {
        info = m.getName().toString() + "(";
        for (int i = 0; i < m.getParameters().size() - 1; ++i)
            info += ",";
        info += ")";
        returnType = m.getReturnType() == null ?
                "void" : m.getReturnType().toString();
        parameters = "";
        for (JCVariableDecl var : m.getParameters()) {
            if (!parameters.equals(""))
                parameters += ", ";
            parameters += var.getType().toString();
        }
        declaringClass = cls;
    }

    public String toString() {
        return info.substring(0, info.indexOf('(')) +
            "(" + parameters + ")" +
            " - " + returnType;
    }

    public int getType() {
        return METHOD;
    }

}
