package plugins;

import java.io.*;
import java.util.*;
import javax.swing.text.*;
import javax.swing.text.AbstractDocument.DefaultDocumentEvent;
import static logging.Logging.logger;

public class Autocorrection extends Plugin {

    HashMap <String, String> dict = new HashMap <String, String> ();

    public Autocorrection() {
        super("Autocorrection");
    }

    public void init() {
        try {
            Scanner sc = new Scanner(new FileInputStream("plugins/Autocorrection.dic"));
            while (sc.hasNext()) {
                String line = sc.next();
                if (line.indexOf('=') == -1)
                    logger.warning("Invalid format for dictionary!");
                else {
                    String left = line.substring(0, line.indexOf('='));
                    String right = line.substring(line.indexOf('=') + 1);
                    dict.put(left, right);
                }
            }
        } catch (IOException e) {
            logger.throwing("plugins.Autocorrection", "init", e);
        }
    }

    public void clear() {
    }

    public void insertUpdate(Document doc, DefaultDocumentEvent chng, AttributeSet attr) {
        super.insertUpdate(doc, chng, attr);

        if (chng.getLength() != 1)
            return;

        try {
            Character ch = doc.getText(chng.getOffset(), 1).charAt(0);
            if (!Character.isJavaIdentifierPart(ch)) {

                StringBuffer buffer = new StringBuffer();
                int pos = chng.getOffset() - 1;

                while (pos >= 0) {
                    Character tmp = doc.getText(pos, 1).charAt(0);
                    if (!Character.isJavaIdentifierPart(tmp))
                        break;
                    buffer.append(tmp);
                    --pos;
                }

                String value = dict.get(buffer.reverse().toString());
                if (value != null) {
                    ((PlainDocument) doc).replace(pos + 1, chng.getOffset() - pos, value + ch, null);
                }
            }
        } catch (BadLocationException e) {
            logger.throwing("plugins.Autocorrection", "insertUpdate", e);
        }

    }

}
