package plugins;

import java.util.*;
import javax.swing.text.*;
import javax.swing.text.AbstractDocument.DefaultDocumentEvent;

public abstract class Plugin {

    String name = null;
    List <ExternAction> actions = new LinkedList <ExternAction> ();

    public Plugin(String name) {
        this.name = name;
    }

    public String getName() {
        return name;
    }

    //a plugin can have multiple extern actions
    protected void registerAction(ExternAction extern) {
        actions.add(extern);
    }

    public List <ExternAction> getActions() {
        return actions;
    }

    // Called when the plugin is activated.
    public abstract void init();

    // Called when the plugin is deactivated.
    public abstract void clear();

    // Called when a document receives an insert change.
    public void insertUpdate(Document doc, DefaultDocumentEvent chng,
            AttributeSet attr) {
    } //plugin on the document

    // Called when a document receives a remove change.
    public void removeUpdate(Document doc, DefaultDocumentEvent chng) {
    }

}
