package plugins;

import java.io.*;
import javax.swing.JFileChooser;
import application.*;
import static logging.Logging.logger;

public class SEOSuggest extends Plugin {

    public SEOSuggest() {
        super("SEO Suggest");
        registerAction(new SEOHTMLGenerator());
    }

    public void init() {
    }

    public void clear() {
    }
    
    public class SEOHTMLGenerator implements ExternAction {

		public String getMessage() {
			return "SEO Suggest";
		}

		public void run() {
			// Generate a correct example HTML page with SEO suggestion
			JFileChooser choose = new JFileChooser();
			if (!(choose.showSaveDialog(Application.getFrame()) == JFileChooser.APPROVE_OPTION)) return;
			
			FileWriter out = null;
            try {
                out = new FileWriter(choose.getSelectedFile());
            } catch (IOException e) {
                return;
            }
           
            startHTML(out);
            endHTML(out);          
            try {
                out.close();
            } catch (IOException e) {
                logger.throwing("HTMLOutput", "run", e);
            }
		}
    	
		private void startHTML(FileWriter out) {
            try {
            	out.write("<!DOCTYPE html PUBLIC " + 
            			  "\"-//W3C//DTD XHTML 1.0 Transitional//EN\"" +
            			  " \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\"" +
            			  ">\n");
                out.write("<html>\n");
                out.write("    <head>\n");
                out.write("        <!-- Choose a title that effectively communicates the topic\n" +
                		  "				of the pages's content. Avoid choosing a title that has\n" +
                		  "				no relation to the content on the page or using default\n" +
                		  "				or vague titles like Untitled or New Page\n" +
                		  "				Each of your pages should ideally have a unique title tag\n" +
                		  "				which helps search engines know how the page is distinct\n" +
                		  "				from the others on your site. Avoid using a single title\n" +
                		  "				across all of your site's pages.\n" +
                		  "				Titles can be both short and informative. If the title is too\n" +
                		  "				long, Google will show only a portion of it in search results. -->\n");
                out.write("        <title>" + "Insert your page title here" + "</title>\n");
                out.write("        <!-- Write a description that would both inform and interest users\n" +
                		  "				if they saw your description meta tag as a snippet in a result.\n" +
                		  "				Avoid using long description ar using a single description meta\n" +
                		  "				tag across all of your site's pages or a large group of pages. -->\n");
                out.write("             <meta http-equiv=" + "\"Content-Type\" " + "content=" +
                		                "\"text/html; charset=ISO-8859-1\"" + "/>\n");
                out.write("             <meta name=" + "\"Keywords\"" + " content=" + "\"Insert your keywords here\"" + "/>\n");
                out.write("             <meta name=" + "\"Description\"" + " content=\"Insert your page description here\"" + "/>\n");
                out.write("                <link rel=" + "\"stylesheet\"" + " type=" +
                		                   "\"text/css\">" + "</link>\n");
                out.write("                <script></script>\n");
                out.write("    </head>\n");
                out.write("    <body>\n");
                out.write("        <pre>\n");
            } catch (IOException e) {
                logger.throwing("HTMLOutput", "startHTML", e);
            }
        }
		
		private void endHTML(FileWriter out) {
            try {
            	out.write("        <h1>" + "Attention! Insert a single h1 tag" + "</h1>\n");
                out.write("        </pre>\n");
                out.write("    </body>\n");
                out.write("</html>\n");
            } catch (IOException e) {
                logger.throwing("HTMLOutput", "startHTML", e);
            }
        }
		
    }//end SEOHTMLGenerator class
    
}//end SEOSuggest class
